searchData={"items":[{"type":"behaviour","title":"Cluster.Strategy","doc":"This module defines the behaviour for implementing clustering strategies.","ref":"Cluster.Strategy.html"},{"type":"callback","title":"Cluster.Strategy.child_spec/1","doc":"","ref":"Cluster.Strategy.html#c:child_spec/1"},{"type":"function","title":"Cluster.Strategy.connect_nodes/4","doc":"Given a list of node names, attempts to connect to all of them.\nReturns `:ok` if all nodes connected, or `{:error, [{node, reason}, ..]}`\nif we failed to connect to some nodes.\n\nAll failures are logged.","ref":"Cluster.Strategy.html#connect_nodes/4"},{"type":"function","title":"Cluster.Strategy.difference/2","doc":"","ref":"Cluster.Strategy.html#difference/2"},{"type":"function","title":"Cluster.Strategy.disconnect_nodes/4","doc":"Given a list of node names, attempts to disconnect from all of them.\nReturns `:ok` if all nodes disconnected, or `{:error, [{node, reason}, ..]}`\nif we failed to disconnect from some nodes.\n\nAll failures are logged.","ref":"Cluster.Strategy.html#disconnect_nodes/4"},{"type":"function","title":"Cluster.Strategy.intersection/2","doc":"","ref":"Cluster.Strategy.html#intersection/2"},{"type":"callback","title":"Cluster.Strategy.start_link/1","doc":"","ref":"Cluster.Strategy.html#c:start_link/1"},{"type":"type","title":"Cluster.Strategy.bad_nodes/0","doc":"","ref":"Cluster.Strategy.html#t:bad_nodes/0"},{"type":"type","title":"Cluster.Strategy.mfa_tuple/0","doc":"","ref":"Cluster.Strategy.html#t:mfa_tuple/0"},{"type":"type","title":"Cluster.Strategy.strategy_args/0","doc":"","ref":"Cluster.Strategy.html#t:strategy_args/0"},{"type":"type","title":"Cluster.Strategy.topology/0","doc":"","ref":"Cluster.Strategy.html#t:topology/0"},{"type":"module","title":"Cluster.Strategy.DNSPoll","doc":"Assumes you have nodes that respond to the specified DNS query (A record), and which follow the node name pattern of\n` @ `. If your setup matches those assumptions, this strategy will periodically poll DNS and connect\nall nodes it finds.","ref":"Cluster.Strategy.DNSPoll.html"},{"type":"module","title":"Options - Cluster.Strategy.DNSPoll","doc":"* `poll_interval` - How often to poll in milliseconds (optional; default: 5_000)\n* `query` - DNS query to use (required; e.g. \"my-app.example.com\")\n* `node_basename` - The short name of the nodes you wish to connect to (required; e.g. \"my-app\")","ref":"Cluster.Strategy.DNSPoll.html#module-options"},{"type":"module","title":"Usage - Cluster.Strategy.DNSPoll","doc":"config :libcluster,\n      topologies: [\n        dns_poll_example: [\n          strategy: Elixir.Cluster.Strategy.DNSPoll,\n          config: [\n            polling_interval: 5_000,\n            query: \"my-app.example.com\",\n            node_basename: \"my-app\"]]]","ref":"Cluster.Strategy.DNSPoll.html#module-usage"},{"type":"function","title":"Cluster.Strategy.DNSPoll.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.DNSPoll.html#child_spec/1"},{"type":"function","title":"Cluster.Strategy.DNSPoll.lookup_all_ips/1","doc":"","ref":"Cluster.Strategy.DNSPoll.html#lookup_all_ips/1"},{"type":"function","title":"Cluster.Strategy.DNSPoll.start_link/1","doc":"","ref":"Cluster.Strategy.DNSPoll.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.Epmd","doc":"This clustering strategy relies on Erlang's built-in distribution protocol.\n\nYou can have libcluster automatically connect nodes on startup for you by configuring\nthe strategy like below:\n\n    config :libcluster,\n      topologies: [\n        epmd_example: [\n          strategy: Elixir.Cluster.Strategy.Epmd,\n          config: [\n            timeout: 30_000,\n            hosts: [:\"a@127.0.0.1\", :\"b@127.0.0.1\"]]]]\n\nAn optional timeout can be specified in the config. This is the timeout that\nwill be used in the GenServer to connect the nodes. This defaults to\n`:infinity` meaning that the connection process will only happen when the\nworker is started. Any integer timeout will result in the connection process\nbeing triggered. In the example above, it has been configured for 30 seconds.","ref":"Cluster.Strategy.Epmd.html"},{"type":"function","title":"Cluster.Strategy.Epmd.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Epmd.html#child_spec/1"},{"type":"module","title":"Cluster.Strategy.ErlangHosts","doc":"This clustering strategy relies on Erlang's built-in distribution protocol by\nusing a `.hosts.erlang` file (as used by the `:net_adm` module).\n\nPlease see [the net_adm docs](http://erlang.org/doc/man/net_adm.html) for more details.\n\nIn short, the following is the gist of how it works:\n\n> File `.hosts.erlang` consists of a number of host names written as Erlang terms. It is looked for in the current work\n> directory, the user's home directory, and $OTP_ROOT (the root directory of Erlang/OTP), in that order.\n\nThis looks a bit like the following in practice:\n\n```erlang\n'super.eua.ericsson.se'.\n'renat.eua.ericsson.se'.\n'grouse.eua.ericsson.se'.\n'gauffin1.eua.ericsson.se'.\n\n```\n\nYou can have `libcluster` automatically connect nodes on startup for you by configuring\nthe strategy like below:\n\n    config :libcluster,\n      topologies: [\n        erlang_hosts_example: [\n          strategy: Elixir.Cluster.Strategy.ErlangHosts,\n          config: [timeout: 30_000]\n        ]\n      ]\n\nAn optional timeout can be specified in the config. This is the timeout that\nwill be used in the GenServer to connect the nodes. This defaults to\n`:infinity` meaning that the connection process will only happen when the\nworker is started. Any integer timeout will result in the connection process\nbeing triggered. In the example above, it has been configured for 30 seconds.","ref":"Cluster.Strategy.ErlangHosts.html"},{"type":"function","title":"Cluster.Strategy.ErlangHosts.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.ErlangHosts.html#child_spec/1"},{"type":"function","title":"Cluster.Strategy.ErlangHosts.start_link/1","doc":"","ref":"Cluster.Strategy.ErlangHosts.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.Gossip","doc":"This clustering strategy uses multicast UDP to gossip node names\nto other nodes on the network. These packets are listened for on\neach node as well, and a connection will be established between the\ntwo nodes if they are reachable on the network, and share the same\nmagic cookie. In this way, a cluster of nodes may be formed dynamically.\n\nThe gossip protocol is extremely simple, with a prelude followed by the node\nname which sent the packet. The node name is parsed from the packet, and a\nconnection attempt is made. It will fail if the two nodes do not share a cookie.\n\nBy default, the gossip occurs on port 45892, using the multicast address 233.252.1.32\n\nThe gossip protocol is not encrypted by default, but can be by providing a secret\nin the configuration of the strategy (as shown below).\nThis can also be used to run multiple clusters with the same multicast configuration,\nas nodes not sharing the same encryption key will not be connected.\n\nYou may configure the multicast interface, multicast address, the interface address to bind to, the port,\nthe TTL of the packets and the optional secret using the following settings:\n\n    config :libcluster,\n      topologies: [\n        gossip_example: [\n          strategy: Elixir.Cluster.Strategy.Gossip,\n          config: [\n            port: 45892,\n            if_addr: \"0.0.0.0\",\n            multicast_if: \"192.168.1.1\",\n            multicast_addr: \"233.252.1.32\",\n            multicast_ttl: 1,\n            secret: \"somepassword\"]]]\n\nA TTL of 1 will limit packets to the local network, and is the default TTL.\n\nOptionally, `broadcast_only: true` option can be set which disables multicast and\nonly uses broadcasting. This limits connectivity to local network but works on in\nscenarios where multicast is not enabled. Use `multicast_addr` as the broadcast address.\n\nExample for broadcast only:\n\n    config :libcluster,\n      topologies: [\n        gossip_example: [\n          strategy: Elixir.Cluster.Strategy.Gossip,\n          config: [\n            port: 45892,\n            if_addr: \"0.0.0.0\",\n            multicast_addr: \"255.255.255.255\",\n            broadcast_only: true]]]\n\nDebug logging is deactivated by default for this clustering strategy, but it can be easily activated by configuring the application:\n\n    use Mix.Config\n\n    config :libcluster,\n      debug: true\n\nAll the checks are done at runtime, so you can flip the debug level without being forced to shutdown your node.","ref":"Cluster.Strategy.Gossip.html"},{"type":"function","title":"Cluster.Strategy.Gossip.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Gossip.html#child_spec/1"},{"type":"function","title":"Cluster.Strategy.Gossip.start_link/1","doc":"","ref":"Cluster.Strategy.Gossip.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.Kubernetes","doc":"This clustering strategy works by fetching information of endpoints or pods, which are filtered by\ngiven Kubernetes namespace and label.\n\n> This strategy requires a service account with the ability to list endpoints or pods. If you want\n> to avoid that, you could use one of the DNS-based strategies instead.\n>\n> See `Cluster.Strategy.Kubernetes.DNS` and `Cluster.Strategy.Kubernetes.DNSSRV`.\n\nIt assumes that all Erlang nodes are using longnames - ` @ `:\n\n+ all nodes are using the same ` `\n+ all nodes are using unique ` `\n\nIn ` @ `:\n\n+ ` ` would be the value configured by `:kubernetes_node_basename` option.\n+ ` ` would be the value which is controlled by following options:\n   - `:kubernetes_namespace`\n   - `:kubernetes_selector`\n   - `:kubernetes_service_name`\n   - `:kubernetes_ip_lookup_mode`\n   - `:mode`","ref":"Cluster.Strategy.Kubernetes.html"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes","doc":"As said above, the basename is configured by `:kubernetes_node_basename` option.\n\nJust one thing to keep in mind - when building an OTP release, make sure that the name of the OTP\nrelease matches the name configured by `:kubernetes_node_basename`.","ref":"Cluster.Strategy.Kubernetes.html#module-getting"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes","doc":"### `:kubernetes_namespace` and `:kubernetes_selector` option\n\nThese two options configure how to filter required endpoints or pods.\n\n### `:kubernetes_ip_lookup_mode` option\n\nThese option configures where to lookup the required IP.\n\nAvailable values:\n\n+ `:endpoints` (default)\n+ `:pods`\n\n#### :endpoints\n\nWhen setting this value, this strategy will lookup IP from endpoints.\n\nIn order for your endpoints to be found they should be returned when you run:\n\n    kubectl get endpoints -l app=myapp\n\nThen, this strategy will fetch the addresses of all endpoints with that label and attempt to\nconnect.\n\n#### :pods\n\nWhen setting this value, this strategy will lookup IP from pods directly.\n\nIn order for your pods to be found they should be returned when you run:\n\n    kubectl get pods -l app=myapp\n\nThen, this strategy will fetch the IP of all pods with that label and attempt to connect.\n\n\n### `:mode` option\n\nThese option configures how to build the longname.\n\nAvailable values:\n\n+ `:ip` (default)\n+ `:dns`\n+ `:hostname`\n\n#### :ip\n\nIn this mode, the IP address is used directly. The longname will be something like:\n\n    myapp@ \n\nGetting this mode to work requires:\n\n1. exposing pod IP from Kubernetes to the Erlang node.\n2. setting the name of Erlang node according to the exposed information\n\nFirst, expose required information from Kubernetes as environment variables of Erlang node:\n\n    # deployment.yaml\n    env:\n    - name: POD_IP\n      valueFrom:\n        fieldRef:\n          fieldPath: status.podIP\n\nThen, set the name of Erlang node by using the exposed environment variables. If you use mix releases, you\ncan configure the required options in `rel/env.sh.eex`:\n\n    # rel/env.sh.eex\n    export RELEASE_DISTRIBUTION=name\n    export RELEASE_NODE=<%= @release.name %>@${POD_IP}\n\n> `export RELEASE_DISTRIBUTION=name` will append a `-name` option to the `start` command directly\n> and requires no further changes to the `vm.args`.\n\n#### :hostname\n\nIn this mode, the hostname is used directly. The longname will be something like:\n\n    myapp@ . . .svc. \n\nGetting `:hostname` mode to work requires:\n\n1. deploying pods as a StatefulSet (otherwise, hostname is not set for pods)\n2. setting `:kubernetes_service_name` to the name of the Kubernetes service that is being lookup\n3. setting the name of Erlang node according to hostname of pods\n\nThen, set the name of Erlang node by using the hostname of pod. If you use mix releases, you can\nconfigure the required options in `rel/env.sh.eex`:\n\n    # rel/env.sh.eex\n    export RELEASE_DISTRIBUTION=name\n    export RELEASE_NODE=<%= @release.name %>@$(hostname -f)\n\n> `hostname -f` returns the whole FQDN, which is something like:\n> `$(hostname).${SERVICE_NAME}.${NAMESPACE}.svc.${CLUSTER_DOMAIN}\"`.\n\n#### :dns\n\nIn this mode, an IP-based pod A record is used. The longname will be something like:\n\n    myapp@ . .pod. \n\nGetting `:dns` mode to work requires:\n\n1. exposing pod IP from Kubernetes to the Erlang node\n2. setting the name of Erlang node according to the exposed information\n\nFirst, expose required information from Kubernetes as environment variables of Erlang node:\n\n    # deployment.yaml\n    env:\n    - name: NAMESPACE\n      valueFrom:\n        fieldRef:\n          fieldPath: metadata.namespace\n    - name: POD_IP\n      valueFrom:\n        fieldRef:\n          fieldPath: status.podIP\n\nThen, set the name of Erlang node by using the exposed environment variables. If you use mix\nreleases, you can configure the required options in `rel/env.sh.eex`:\n\n    # rel/env.sh.eex\n    export POD_A_RECORD=$(echo $POD_IP | sed 's/./-/g')\n    export CLUSTER_DOMAIN=cluster.local  # modify this value according to your actual situation\n    export RELEASE_DISTRIBUTION=name\n    export RELEASE_NODE=<%= @release.name %>@${POD_A_RECORD}.${NAMESPACE}.pod.${CLUSTER_DOMAIN}","ref":"Cluster.Strategy.Kubernetes.html#module-getting"},{"type":"module","title":"Which mode is the best one? - Cluster.Strategy.Kubernetes","doc":"There is no best, only the best for you:\n\n+ If you're not using a StatefulSet, use `:ip` or `:dns`.\n+ If you're using a StatefulSet, use `:hostname`.\n\nAnd, there is one thing that can be taken into consideration. When using `:ip` or `:dns`, you\ncan establish a remote shell (as well as run observer) by using `kubectl port-forward` in combination\nwith some entries in `/etc/hosts`.","ref":"Cluster.Strategy.Kubernetes.html#module-which-mode-is-the-best-one"},{"type":"module","title":"Polling Interval - Cluster.Strategy.Kubernetes","doc":"The default interval to sync topologies is `5000`\n(5 seconds). You can configure it with `:polling_interval` option.","ref":"Cluster.Strategy.Kubernetes.html#module-polling-interval"},{"type":"module","title":"Getting cluster information - Cluster.Strategy.Kubernetes","doc":"> In general, you don't need to read this, the default values will work.\n\nThis strategy fetchs information of endpoints or pods by accessing the REST API provided by\nKubernetes.\n\nThe base URL of the REST API has two parts:\n\n     . \n\n` ` is configured by following options:\n\n+ `:kubernetes_master` - the default value is `kubernetes.default.svc`\n\n` ` is configured by following options and environment variables:\n\n+ `:kubernetes_cluster_name` - the default value is `cluster`, and the final cluster domain will be ` .local`\n+ `CLUSTER_DOMAIN` - when this environment variable is provided, `:kubernetes_cluster_name` will be ignored\n\n> ` ` and ` ` also affect each other, checkout the source code for more\n> details.\n\nBesides the base URL of the REST API, a service account must be provided. The service account is\nconfigured by following options:\n\n+ `:kubernetes_service_account_path` - the default value is `/var/run/secrets/kubernetes.io/serviceaccount`","ref":"Cluster.Strategy.Kubernetes.html#module-getting-cluster-information"},{"type":"module","title":"An example configuration - Cluster.Strategy.Kubernetes","doc":"config :libcluster,\n      topologies: [\n        erlang_nodes_in_k8s: [\n          strategy: Elixir.Cluster.Strategy.Kubernetes,\n          config: [\n            mode: :ip,\n            kubernetes_node_basename: \"myapp\",\n            kubernetes_selector: \"app=myapp\",\n            kubernetes_namespace: \"my_namespace\",\n            polling_interval: 10_000\n          ]\n        ]\n      ]","ref":"Cluster.Strategy.Kubernetes.html#module-an-example-configuration"},{"type":"function","title":"Cluster.Strategy.Kubernetes.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Kubernetes.html#child_spec/1"},{"type":"function","title":"Cluster.Strategy.Kubernetes.start_link/1","doc":"","ref":"Cluster.Strategy.Kubernetes.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.Kubernetes.DNS","doc":"This clustering strategy works by fetching IP addresses with the help of a headless service in\ncurrent Kubernetes namespace.\n\n> This strategy requires exposing pods by a headless service.\n> If you want to avoid that, you could use `Cluster.Strategy.Kubernetes`.\n\nIt assumes that all Erlang nodes are using longnames - ` @ `:\n\n+ all nodes are using the same ` `\n+ all nodes are using unique ` `\n\nIn ` @ `:\n\n+ ` ` would be the value configured by `:application_name` option.\n+ ` ` would be the value which is controlled by following options:\n   - `:service`\n   - `:resolver`","ref":"Cluster.Strategy.Kubernetes.DNS.html"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes.DNS","doc":"As said above, the basename is configured by `:application_name` option.\n\nJust one thing to keep in mind - when building an OTP release, make sure that the name of the OTP\nrelease matches the name configured by `:application_name`.","ref":"Cluster.Strategy.Kubernetes.DNS.html#module-getting"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes.DNS","doc":"It will fetch IP addresses of all pods under a headless service and attempt to connect.","ref":"Cluster.Strategy.Kubernetes.DNS.html#module-getting"},{"type":"module","title":"Setup - Cluster.Strategy.Kubernetes.DNS","doc":"Getting this strategy to work requires:\n\n1. exposing pod IP from Kubernetes to the Erlang node.\n2. setting a headless service for the pods\n3. setting the name of Erlang node according to the exposed information\n\nFirst, expose required information from Kubernetes as environment variables of Erlang node:\n\n    # deployment.yaml\n    env:\n    - name: POD_IP\n      valueFrom:\n        fieldRef:\n          fieldPath: status.podIP\n\nSecond, set a headless service for the pods:\n\n    # deployment.yaml\n    apiVersion: v1\n    kind: Service\n    metadata:\n      name: myapp-headless\n    spec:\n      selector:\n        app: myapp\n      type: ClusterIP\n      clusterIP: None\n\nThen, set the name of Erlang node by using the exposed environment variables. If you use mix releases, you\ncan configure the required options in `rel/env.sh.eex`:\n\n    # rel/env.sh.eex\n    export RELEASE_DISTRIBUTION=name\n    export RELEASE_NODE=<%= @release.name %>@${POD_IP}","ref":"Cluster.Strategy.Kubernetes.DNS.html#module-setup"},{"type":"module","title":"Polling Interval - Cluster.Strategy.Kubernetes.DNS","doc":"The default interval to sync topologies is `5000`\n(5 seconds). You can configure it with `:polling_interval` option.","ref":"Cluster.Strategy.Kubernetes.DNS.html#module-polling-interval"},{"type":"module","title":"An example configuration - Cluster.Strategy.Kubernetes.DNS","doc":"config :libcluster,\n      topologies: [\n        erlang_nodes_in_k8s: [\n          strategy: Elixir.Cluster.Strategy.Kubernetes.DNS,\n          config: [\n            service: \"myapp-headless\",\n            application_name: \"myapp\",\n            polling_interval: 10_000\n          ]\n        ]\n      ]","ref":"Cluster.Strategy.Kubernetes.DNS.html#module-an-example-configuration"},{"type":"function","title":"Cluster.Strategy.Kubernetes.DNS.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Kubernetes.DNS.html#child_spec/1"},{"type":"module","title":"Cluster.Strategy.Kubernetes.DNSSRV","doc":"This clustering strategy works by issuing a SRV query for the headless service where the StatefulSet\ncontaining your nodes is running.\n\n> This strategy requires deploying pods as a StatefulSet which is exposed by a headless service.\n> If you want to avoid that, you could use `Cluster.Strategy.Kubernetes.DNS`.\n\nIt assumes that all Erlang nodes are using longnames - ` @ `:\n\n+ all nodes are using the same ` `\n+ all nodes are using unique ` `\n\nIn ` @ `:\n\n+ ` ` would be the value configured by `:application_name` option.\n+ ` ` would be the value which is controlled by following options:\n   - `:service`\n   - `:namespace`\n   - `:resolver`","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes.DNSSRV","doc":"As said above, the basename is configured by `:application_name` option.\n\nJust one thing to keep in mind - when building an OTP release, make sure that the name of the OTP\nrelease matches the name configured by `:application_name`.","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-getting"},{"type":"module","title":"Getting ` ` - Cluster.Strategy.Kubernetes.DNSSRV","doc":"> For more information, see the kubernetes stateful-application [documentation](https://kubernetes.io/docs/tutorials/stateful-application/basic-stateful-set/#using-stable-network-identities)","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-getting"},{"type":"module","title":"Setup - Cluster.Strategy.Kubernetes.DNSSRV","doc":"Getting this strategy to work requires:\n\n1. deploying pods as a StatefulSet (otherwise, hostname won't set for pods)\n2. exposing above StatefulSet by a headless service (otherwise, the SRV query won't work as expected)\n3. setting the name of Erlang node according to hostname of pods\n\nFirst, deploying pods as a StatefulSet which is exposed by a headless service. And here is an\nexample of a corresponding Kubernetes definition:\n\n```yaml\napiVersion: v1\nkind: Service\nmetadata:\n  name: \"myapp-headless\"\n  labels:\n    app: myapp\nspec:\n  ports:\n  - port: 4000\n    name: web\n  clusterIP: None\n  selector:\n    app: myapp\n---\napiVersion: apps/v1\nkind: StatefulSet\nmetadata:\n  name: myapp\nspec:\n  serviceName: \"myapp-headless\"\n  replicas: 2\n  selector:\n    matchLabels:\n      app: myapp\n  template:\n    metadata:\n      labels:\n        app: myapp\n    spec:\n      containers:\n      - name: myapp\n        image: myapp:v1.0.0\n        imagePullPolicy: Always\n        ports:\n        - containerPort: 4000\n          name: http\n          protocol: TCP\n```\n\nThen, set the name of Erlang node by using the hostname of pod. If you use mix releases, you\ncan configure the required options in `rel/env.sh.eex`:\n\n    # rel/env.sh.eex\n    export RELEASE_DISTRIBUTION=name\n    export RELEASE_NODE=<%= @release.name %>@$(hostname -f)","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-setup"},{"type":"module","title":"Polling Interval - Cluster.Strategy.Kubernetes.DNSSRV","doc":"The default interval to sync topologies is `5000`\n(5 seconds). You can configure it with `:polling_interval` option.","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-polling-interval"},{"type":"module","title":"An example configuration - Cluster.Strategy.Kubernetes.DNSSRV","doc":"config :libcluster,\n      topologies: [\n        erlang_nodes_in_k8s: [\n          strategy: Elixir.Cluster.Strategy.Kubernetes.DNSSRV,\n          config: [\n            service: \"myapp-headless\",\n            application_name: \"myapp\",\n            namespace: \"default\",\n            polling_interval: 10_000\n          ]\n        ]\n      ]","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-an-example-configuration"},{"type":"module","title":"An example of how this strategy extracts topology information from DNS - Cluster.Strategy.Kubernetes.DNSSRV","doc":"```sh\n$ hostname -f\nmyapp-1.myapp-headless.default.svc.cluster.local\n\n# An SRV query for a headless service returns multiple entries\n$ dig SRV myapp-headless.default.svc.cluster.local\n\n; <<>> DiG 9.14.3 <<>> SRV myapp-headless.default.svc.cluster.local\n;; global options: +cmd\n;; Got answer:\n;; WARNING: .local is reserved for Multicast DNS\n;; You are currently testing what happens when an mDNS query is leaked to DNS\n;; ->>HEADER<<- opcode: QUERY, status: NOERROR, id: 7169\n;; flags: qr aa rd ra; QUERY: 1, ANSWER: 2, AUTHORITY: 0, ADDITIONAL: 2\n\n;; QUESTION SECTION:\n;myapp-headless.default.svc.cluster.local. IN SRV\n\n;; ANSWER SECTION:\nmyapp-headless.default.svc.cluster.local. 30 IN SRV 10 50 0 myapp-0.myapp-headless.default.svc.cluster.local.\nmyapp-headless.default.svc.cluster.local. 30 IN SRV 10 50 0 myapp-1.myapp-headless.default.svc.cluster.local.\n\n;; ADDITIONAL SECTION:\nmyapp-0.myapp-headless.default.svc.cluster.local. 30 IN A 10.1.0.95\nmyapp--1.myapp-headless.default.svc.cluster.local. 30 IN A 10.1.0.96\n\n;; Query time: 0 msec\n;; SERVER: 10.96.0.10#53(10.96.0.10)\n;; WHEN: Wed Jul 03 11:55:27 UTC 2019\n;; MSG SIZE  rcvd: 167\n```","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#module-an-example-of-how-this-strategy-extracts-topology-information-from-dns"},{"type":"function","title":"Cluster.Strategy.Kubernetes.DNSSRV.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Kubernetes.DNSSRV.html#child_spec/1"},{"type":"module","title":"Cluster.Strategy.LocalEpmd","doc":"This clustering strategy relies on Erlang's built-in distribution protocol.\n\nUnlike Cluster.Strategy.Epmd, this strategy assumes that all nodes are on\nthe local host and can be discovered by epmd.\n\nMake sure `epmd` is started before you start your application, or startup\nwill fail. When running with `mix`, you can do this automatically by passing\nthe `--name` or `--sname` flag to start distribution.\n\nIt should be configured as follows:\n\n    config :libcluster,\n      topologies: [\n        local_epmd_example: [\n          strategy: Elixir.Cluster.Strategy.LocalEpmd]]","ref":"Cluster.Strategy.LocalEpmd.html"},{"type":"function","title":"Cluster.Strategy.LocalEpmd.start_link/1","doc":"","ref":"Cluster.Strategy.LocalEpmd.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.Rancher","doc":"This clustering strategy is specific to the Rancher container platform.\nIt works by querying the platform's metadata API for containers belonging to\nthe same service as the node and attempts to connect them.\n(see: http://rancher.com/docs/rancher/latest/en/rancher-services/metadata-service/)\n\nIt assumes that all nodes share a base name and are using longnames of the form\n` ` where the ` ` is unique for each node.\n\nA way to assign a name to a node on boot in an app running as a Distillery release is:\n\nCreate a wrapper script which will interpolate the current ip of the container.\n\n```sh\n#!/bin/sh\n\nexport CONTAINER_IP=\"$(hostname -I | cut -f1 -d' ')\"\nexport REPLACE_OS_VARS=true\n\n/app/bin/app \"$@\"\n```\n\n```\n# vm.args\n-name app@${CONTAINER_IP}\n```\n\nAn example configuration is below:\n\n\n    config :libcluster,\n      topologies: [\n        rancher_example: [\n          strategy: Elixir.Cluster.Strategy.Rancher,\n          config: [\n            node_basename: \"myapp\",\n            polling_interval: 10_000]]]","ref":"Cluster.Strategy.Rancher.html"},{"type":"function","title":"Cluster.Strategy.Rancher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Strategy.Rancher.html#child_spec/1"},{"type":"function","title":"Cluster.Strategy.Rancher.start_link/1","doc":"","ref":"Cluster.Strategy.Rancher.html#start_link/1"},{"type":"module","title":"Cluster.Strategy.State","doc":"The state of one strategy.","ref":"Cluster.Strategy.State.html"},{"type":"type","title":"Cluster.Strategy.State.t/0","doc":"","ref":"Cluster.Strategy.State.html#t:t/0"},{"type":"module","title":"Cluster.Supervisor","doc":"This module handles supervising the configured topologies, and is designed\nto support being started within your own supervision tree, as shown below:\n\n    defmodule MyApp.App do\n      use Application\n\n      def start(_type, _args) do\n        topologies = [\n          example: [\n            strategy: Cluster.Strategy.Epmd,\n            config: [hosts: [:\"a@127.0.0.1\", :\"b@127.0.0.1\"]],\n          ]\n        ]\n        children = [\n          {Cluster.Supervisor, [topologies, [name: MyApp.ClusterSupervisor]]},\n          ..other children..\n        ]\n        Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n      end\n    end\n\nThe `topologies` configuration structure shown above can be built manually,\nlike shown, so that you can load config at runtime in a way that best\nsuits your application; or if you don't need to do any special config\nhandling, you can use the Mix config file, and just use\n`Application.get_env(:libcluster, :topologies)`. That config would look like so:\n\n    config :libcluster,\n      topologies: [\n        example: [...]\n      ]\n\nUse the method most convenient for you.","ref":"Cluster.Supervisor.html"},{"type":"function","title":"Cluster.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Cluster.Supervisor.html#child_spec/1"},{"type":"function","title":"Cluster.Supervisor.start_link/1","doc":"Start a new instance of this supervisor. This is the callback indicated in\nthe child specification returned by `child_spec/1`. It expects a list of\nthe form `[config, supervisor_opts]`, or `[config]`. The former allows you\nto provide options for the supervisor like with `Supervisor.start_link/3`.","ref":"Cluster.Supervisor.html#start_link/1"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"- Use new cypher names\n- Allow Epmd strategy to reconnect after connection failures\n- Detect Self Signed Certificate Authority for Kubernetes Strategy\n- Remove calls to deprecated `Logger.warn/2`\n- Correct misspell of 'Empd' -> 'Epmd' in `Cluster.Strategy.LocalEpmd` moduledoc","ref":"changelog.html#unreleased"},{"type":"extras","title":"3.4.0 - Changelog","doc":"","ref":"changelog.html#3-4-0"},{"type":"extras","title":"Added - Changelog","doc":"- Telemetry events added for tracking node connects and disconnects","ref":"changelog.html#added"},{"type":"extras","title":"3.3.0 - Changelog","doc":"","ref":"changelog.html#3-3-0"},{"type":"extras","title":"Changed - Changelog","doc":"- Default multicast address is now 233.252.1.32, was 230.1.1.251, [commit](https://github.com/bitwalker/libcluster/commit/449a65e14f152a83a0f8ee371f05743610cd292f)","ref":"changelog.html#changed"},{"type":"extras","title":"2.3.0 - Changelog","doc":"","ref":"changelog.html#2-3-0"},{"type":"extras","title":"Added - Changelog","doc":"- Clustering strategy for the Rancher container platform (see: https://github.com/rancher/rancher)\n- LocalEpmd strategy that uses epmd to discover nodes on the local host\n- Gossip strategy multicast interface is used for adding multicast membership","ref":"changelog.html#added"},{"type":"extras","title":"2.0.0 - Changelog","doc":"","ref":"changelog.html#2-0-0"},{"type":"extras","title":"Added - Changelog","doc":"- Configurable `connect` and `disconnect` options for implementing strategies\n  on top of custom topologies\n- The ability to start libcluster for more than a single topology\n- Added `polling_interval` option to Kubernetes strategy\n- Added ability to specify a list of hosts for the Epmd strategy to connect to on start","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- Cluster.Events module, as it was redundant and unused","ref":"changelog.html#removed"},{"type":"extras","title":"Changed - Changelog","doc":"- Configuration format has changed significantly, please review the docs","ref":"changelog.html#changed"},{"type":"extras","title":"libcluster","doc":"# libcluster\n\n[![Build Status](https://github.com/bitwalker/libcluster/workflows/elixir/badge.svg?branch=main)](https://github.com/bitwalker/libcluster/actions?query=workflow%3A%22elixir%22+branch%3Amain)\n[![Module Version](https://img.shields.io/hexpm/v/libcluster.svg)](https://hex.pm/packages/libcluster)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/libcluster/)\n[![Total Download](https://img.shields.io/hexpm/dt/libcluster.svg)](https://hex.pm/packages/libcluster)\n[![License](https://img.shields.io/hexpm/l/libcluster.svg)](https://github.com/bitwalker/libcluster/blob/main/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/bitwalker/libcluster.svg)](https://github.com/bitwalker/libcluster/commits/main)\n\nThis library provides a mechanism for automatically forming clusters of Erlang nodes, with\neither static or dynamic node membership. It provides a pluggable \"strategy\" system, with a variety of strategies\nprovided out of the box.\n\nYou can find supporting documentation [here](https://hexdocs.pm/libcluster).","ref":"readme.html"},{"type":"extras","title":"Features - libcluster","doc":"- Automatic cluster formation/healing\n- Choice of multiple clustering strategies out of the box:\n  - Standard Distributed Erlang facilities (e.g. `epmd`, `.hosts.erlang`), which supports IP-based or DNS-based names\n  - Multicast UDP gossip, using a configurable port/multicast address,\n  - Kubernetes via its metadata API using via a configurable label selector and\n    node basename; or alternatively, using DNS.\n  - Rancher, via its [metadata API][rancher-api]\n- Easy to provide your own custom clustering strategies for your specific environment.\n- Easy to use provide your own distribution plumbing (i.e. something other than\n  Distributed Erlang), by implementing a small set of callbacks. This allows\n  `libcluster` to support projects like\n  [Partisan](https://github.com/lasp-lang/partisan).","ref":"readme.html#features"},{"type":"extras","title":"Installation - libcluster","doc":"```elixir\ndefp deps do\n  [{:libcluster, \"~> MAJ.MIN\"}]\nend\n```\n\nYou can determine the latest version by running `mix hex.info libcluster` in\nyour shell, or by going to the `libcluster` [page on Hex.pm](https://hex.pm/packages/libcluster).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - libcluster","doc":"It is easy to get started using `libcluster`, simply decide which strategy you\nwant to use to form a cluster, define a topology, and then start the `Cluster.Supervisor` module in\nthe supervision tree of an application in your Elixir system, as demonstrated below:\n\n```elixir\ndefmodule MyApp.App do\n  use Application\n\n  def start(_type, _args) do\n    topologies = [\n      example: [\n        strategy: Cluster.Strategy.Epmd,\n        config: [hosts: [:\"a@127.0.0.1\", :\"b@127.0.0.1\"]],\n      ]\n    ]\n    children = [\n      {Cluster.Supervisor, [topologies, [name: MyApp.ClusterSupervisor]]},\n      # ..other children..\n    ]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\nend\n```\n\nThe following section describes topology configuration in more detail.","ref":"readme.html#usage"},{"type":"extras","title":"Example Configuration - libcluster","doc":"You can configure `libcluster` either in your Mix config file (`config.exs`) as\nshown below, or construct the keyword list structure manually, as shown in the\nprevious section. Either way, you need to pass the configuration to the\n`Cluster.Supervisor` module in it's start arguments. If you prefer to use Mix\nconfig files, then simply use `Application.get_env(:libcluster, :topologies)` to\nget the config that `Cluster.Supervisor` expects.\n\n```elixir\nconfig :libcluster,\n  topologies: [\n    epmd_example: [\n      # The selected clustering strategy. Required.\n      strategy: Cluster.Strategy.Epmd,\n      # Configuration for the provided strategy. Optional.\n      config: [hosts: [:\"a@127.0.0.1\", :\"b@127.0.0.1\"]],\n      # The function to use for connecting nodes. The node\n      # name will be appended to the argument list. Optional\n      connect: {:net_kernel, :connect_node, []},\n      # The function to use for disconnecting nodes. The node\n      # name will be appended to the argument list. Optional\n      disconnect: {:erlang, :disconnect_node, []},\n      # The function to use for listing nodes.\n      # This function must return a list of node names. Optional\n      list_nodes: {:erlang, :nodes, [:connected]},\n    ],\n    # more topologies can be added ...\n    gossip_example: [\n      # ...\n    ]\n  ]\n```","ref":"readme.html#example-configuration"},{"type":"extras","title":"Strategy Configuration - libcluster","doc":"For instructions on configuring each strategy included with `libcluster`, please\nvisit the docs on [HexDocs](https://hexdocs.pm/libcluster), and look at the\nmodule doc for the strategy you want to use. The authoritative documentation for\neach strategy is kept up to date with the module implementing it.","ref":"readme.html#strategy-configuration"},{"type":"extras","title":"Clustering - libcluster","doc":"You have a handful of choices with regards to cluster management out of the box:\n\n- `Cluster.Strategy.Epmd`, which relies on `epmd` to connect to a configured set\n  of hosts.\n- `Cluster.Strategy.LocalEpmd`, which relies on `epmd` to connect to discovered\n  nodes on the local host.\n- `Cluster.Strategy.ErlangHosts`, which uses the `.hosts.erlang` file to\n  determine which hosts to connect to.\n- `Cluster.Strategy.Gossip`, which uses multicast UDP to form a cluster between\n  nodes gossiping a heartbeat.\n- `Cluster.Strategy.Kubernetes`, which uses the Kubernetes Metadata API to query\n  nodes based on a label selector and basename.\n- `Cluster.Strategy.Kubernetes.DNS`, which uses DNS to join nodes under a shared\n  headless service in a given namespace.\n- `Cluster.Strategy.Rancher`, which like the Kubernetes strategy, uses a\n  metadata API to query nodes to cluster with.\n\nYou can also define your own strategy implementation, by implementing the\n`Cluster.Strategy` behavior. This behavior expects you to implement a\n`start_link/1` callback, optionally overriding `child_spec/1` if needed. You don't necessarily have\nto start a process as part of your strategy, but since it's very likely you will need to maintain some state, designing your\nstrategy as an OTP process (e.g. `GenServer`) is the ideal method, however any\nvalid OTP process will work. See the `Cluster.Strategy` module for details on\nthe callbacks you need to implement and the arguments they receive.\n\nIf you do not wish to use the default Erlang distribution protocol, you may provide an alternative means of connecting/\ndisconnecting nodes via the `connect` and `disconnect` configuration options, if not using Erlang distribution you must provide a `list_nodes` implementation as well.\nThey take a `{module, fun, args}` tuple, and append the node name being targeted to the `args` list. How to implement distribution in this way is left as an\nexercise for the reader, but I recommend taking a look at the [Firenest](https://github.com/phoenixframework/firenest) project\ncurrently under development. By default, `libcluster` uses Distributed Erlang.","ref":"readme.html#clustering"},{"type":"extras","title":"Third-Party Strategies - libcluster","doc":"The following list of third-party strategy implementations is not comprehensive,\nbut are known to exist.\n\n- [libcluster_ec2](https://github.com/kyleaa/libcluster_ec2) - EC2 clustering strategy based on tags\n- [libcluster_droplet](https://github.com/jsonmaur/libcluster-droplet) - Digital Ocean Droplet clustering strategy\n- [libcluster_consul](https://github.com/team-telnyx/libcluster_consul) - Consul clustering strategy","ref":"readme.html#third-party-strategies"},{"type":"extras","title":"Copyright and License - libcluster","doc":"Copyright (c) 2016 Paul Schoenfelder\n\nThis library is MIT licensed. See the\n[LICENSE.md](https://github.com/bitwalker/libcluster/blob/master/LICENSE.md) for details.\n\n[rancher-api]: http://rancher.com/docs/rancher/latest/en/rancher-services/metadata-service/","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}